#!/usr/bin/env python

# ------ no changes below! If you need to change, it's a bug! -------
from distutils.core import setup, Extension
import os, sys
version = '0.50'

# there is an error in distutils when building rpms with PYTHONOPTIMIZE set:
if os.environ.has_key('PYTHONOPTIMIZE'):
    del os.environ['PYTHONOPTIMIZE']

longdesc = """ FuGrep means fuzzy grep, which is inexact string
matching.  FuGrep is a replacement for agrepy, which works nice but
has a very unpythonic interface. FuGrep uses agrep for the underlying
functions and uses concepts of agrepy, but replaces the python wrapper
with its own code. """

args = { 'name' : "FuGrep",
         'version' : version,
         'description' : "Python bindings to agrep, a fuzzy string matching tool",
         'long_description' : longdesc,
         'license' : "BSD License - http://www.opensource.org/licenses/bsd-license.php",
         'author' : "Joerg Raedler",
         'author_email' : "jr@j-raedler.de",
         'maintainer' : "Joerg Raedler",
         'maintainer_email' : "jr@j-raedler.de",
         'url' : "http://j-raedler.de/pages/software/fugrep.php",
         'py_modules' : ["FuGrep"],
         'ext_modules' : [Extension('cFuGrep', sources = ['cFuGrep.c', 'agrepy_all.c'],
                                    define_macros=[('FUGREPVERSION', version)])]
         }
if sys.version_info[:3] >= (2,2,3):
    args['download_url'] = "http://j-raedler.de/pages/software/fugrep.php"
    args['classifiers'] = ['Development Status :: 4 - Beta',
                           'Intended Audience :: Developers',
                           'License :: Freely Distributable',
                           'Programming Language :: C',
                           'Operating System :: OS Independent',
                           'Topic :: Software Development'
                           ]

setup(**args)
